      implicit none
      real, allocatable :: m (:,:), m2 (:,:), m3 (:,:), m4 (:,:)
      real, allocatable :: m5 (:,:), m6 (:,:), m7 (:,:), m8 (:,:)
      integer step,count,tick0,tick1,k,s,i,j,istat
      real Mbs, temp, avetim,s2

C*************begin
      s = 2000       
      do k = 1, 125
        write(*,*)
        MBs = 8.0*4.0*s*s/(1024.0*1024) 
        s2 = s
        step = NINT(1.5*Log(s2)) - 4
        write(*,*)'trying to allocate 8 square matrices dimension ',s
        write(*,122)' total ram size (Mb): ',MBs
122     Format(1x,A,F13.5)
        allocate(m(s,s),stat=istat)
        if (istat.ne.0) then
          write(*,*)'CAN NOT allocate matrix 1.....Terminating'
          STOP
        endif
        allocate(m2(s,s),stat=istat)
        if (istat.ne.0) then
          write(*,*)'CAN NOT allocate matrix 2.....Terminating'
          STOP
        endif
        allocate(m3(s,s),stat=istat)
        if (istat.ne.0) then
          write(*,*)'CAN NOT allocate matrix 3.....Terminating'
          STOP
        endif
        allocate(m4(s,s),stat=istat)
        if (istat.ne.0) then
          write(*,*)'CAN NOT allocate matrix 4.....Terminating'
          STOP
        endif

        allocate(m5(s,s),stat=istat)
        if (istat.ne.0) then
          write(*,*)'CAN NOT allocate matrix 5.....Terminating'
          STOP
        endif

        allocate(m6(s,s),stat=istat)
        if (istat.ne.0) then
          write(*,*)'CAN NOT allocate matrix 6.....Terminating'
          STOP
        endif

        allocate(m7(s,s),stat=istat)
        if (istat.ne.0) then
          write(*,*)'CAN NOT allocate matrix 7.....Terminating'
          STOP
        endif

        allocate(m8(s,s),stat=istat)
        if (istat.ne.0) then
          write(*,*)'CAN NOT allocate matrix 8.....Terminating'
          STOP
        endif
  


        write(*,*)'allocated OK ..now testing access time, step=',step
     
        call Timer(tick0)
        count = 0
        do 10 i = 1, s,step
          do 10 j = 1, s,step
            count = count + 1
            m2(i,j) = i+j
            m4(i,j) = i+j
            m3(i,j) = i+j
10          m(i,j) = i+j
        do 20 i = 1, s,step
          do 20 j = 1, s,step
            temp = m(i,j) + m2(i,j)+ m4(i,j)
            m(i,j) = m(j,i) + m3(i,j)
            m(j,i) = temp
20      continue
        call Timer(tick1)
        avetim = 1000.0*(10.0*tick1-10.0*tick0)/count
        write(*,122)' time per cell access ', avetim
        deallocate(m,m2,m3,m4,stat=istat)
        if (istat.ne.0) then
          write(*,*)'CAN NOT deallocate matrices A.....Terminating'
          STOP
        endif
        deallocate(m5,m6,m7,m8,stat=istat)
        if (istat.ne.0) then
          write(*,*)'CAN NOT deallocate matrices B.....Terminating'
          STOP
        endif
          write(*,*)'deallocated OK'
        s = NINT(1.05*s)
      enddo
      STOP
      END
