      implicit none
      real, allocatable :: m1(:,:),m2(:,:),m3(:,:),m4(:,:),m5(:,:)
      integer siz, istat
      real MB1,MB2,MB3,MB4,MB5
      logical report
C*************begin
      report = .false.

      call bigstfree(siz,report) 
331   allocate(m1(siz,siz),stat=istat)
      if (istat.ne.0) then
        write(*,*)'Error: could not reallocate ', siz
        siz = siz - 1
        goto 331
      endif
      call megsiz(siz,MB1)

      call bigstfree(siz,report) 
332   allocate(m2(siz,siz),stat=istat)
      if (istat.ne.0) then
        write(*,*)'Error: could not reallocate ', siz
        siz = siz - 1
        goto 332
      endif
      call megsiz(siz,MB2)

      call bigstfree(siz,report) 
333   allocate(m3(siz,siz),stat=istat)
      if (istat.ne.0) then
        write(*,*)'Error: could not reallocate ', siz
        siz = siz - 1
        goto 333
      endif
      call megsiz(siz,MB3)

      call bigstfree(siz,report) 
334   allocate(m4(siz,siz),stat=istat)
      if (istat.ne.0) then
        write(*,*)'Error: could not reallocate ', siz
        siz = siz - 1
        goto 334
      endif
      call megsiz(siz,MB4)

      call bigstfree(siz,report) 
335   allocate(m5(siz,siz),stat=istat)
      if (istat.ne.0) then
        write(*,*)'Error: could not reallocate ', siz
        siz = siz - 1
        goto 335
      endif
      call megsiz(siz,MB5)

      write(*,322)'total alloc (MB) ',MB1+MB2+MB3+MB4+MB5
322   Format(1x,A,F13.2)

      STOP
      END

      
      subroutine megsiz(siz,mb) 
      implicit none
      integer siz,siz2
      real mb,mb2,delmb
      siz2 = siz + 1
      MB =  4.0*(siz/1024.0)*(siz/1024.0) 
      MB2 = 4.0*(siz2/1024.0)*(siz2/1024.0) 
      delmb = mb2 - mb
      write(*,122)'best alloc (MB) ',Mb,delmb, siz
      return
122   Format(1x,A,2F13.2,3x,I8)
      end

      subroutine bigstfree(bestsiz,rpt) 
      implicit none
      real, allocatable :: mat (:,:)
      integer bestsiz, siz, step, istat
      logical rpt
C*************begin
        siz = 0
        step = 2
        bestsiz = 0       
111     continue
        if (step<1) goto 222
        siz = bestsiz + step 
        if (siz >16383) then
          step = step/2
          goto 111
        endif
 
        if (siz<1) goto 222
        if (rpt) write(*,*)'try to allocate ',siz
        !write(*,*)'try to allocate ',siz

        allocate(mat(siz,siz),stat=istat)
        if (istat.ne.0) then
          if (rpt) write(*,*)'could not allocate ',siz,' step=',step
          step = step/2
          goto 111
        endif
        if (rpt) 
     *  write(*,*)'ALLOCATED ',siz,' step=',step,' bestsiz=',bestsiz
        deallocate(mat,stat=istat)
        if (istat.ne.0) then
          if (rpt) write(*,*)'CAN NOT deallocate.....Terminating'
          STOP
        endif
        bestsiz = siz     
        if (step<1000) step = step*2
        goto 111
222     continue
        return
        END 
